import { ComputeArrayNode } from '@compute.ts/array';
import { ComputeBooleanNode } from '@compute.ts/boolean';
import { ComputeDateNode } from '@compute.ts/date';
import { ComputeDictionaryNode } from '@compute.ts/dictionary';
import { ComputeNumberNode } from '@compute.ts/number';
import { ComputeStringNode } from '@compute.ts/string';
import { ComputeIfNode } from './ComputeIfNode';
export declare class If {
    private node;
    constructor(node: ComputeBooleanNode);
    get asBoolean(): ComputeIfNode<ComputeBooleanNode, boolean>;
    get asNumber(): ComputeIfNode<ComputeNumberNode, number>;
    get asString(): ComputeIfNode<ComputeStringNode, string>;
    get asDate(): ComputeIfNode<ComputeDateNode, Date>;
    get asBooleanArray(): ComputeIfNode<ComputeArrayNode<ComputeBooleanNode, boolean>, boolean[]>;
    get asNumberArray(): ComputeIfNode<ComputeArrayNode<ComputeNumberNode, number>, number[]>;
    get asStringArray(): ComputeIfNode<ComputeArrayNode<ComputeStringNode, string>, string[]>;
    get asDateArray(): ComputeIfNode<ComputeArrayNode<ComputeDateNode, Date>, Date[]>;
    get asDictionaryOfBoolean(): ComputeIfNode<ComputeDictionaryNode<ComputeBooleanNode, boolean>, {
        [key: string]: boolean;
    }>;
    get asDictionaryOfNumber(): ComputeIfNode<ComputeDictionaryNode<ComputeNumberNode, number>, {
        [key: string]: number;
    }>;
    get asDictionaryOfString(): ComputeIfNode<ComputeDictionaryNode<ComputeStringNode, string>, {
        [key: string]: string;
    }>;
    get asDictionaryOfDate(): ComputeIfNode<ComputeDictionaryNode<ComputeDateNode, Date>, {
        [key: string]: Date;
    }>;
    get asDictionaryOfBooleanArray(): ComputeIfNode<ComputeDictionaryNode<ComputeArrayNode<ComputeBooleanNode, boolean>, boolean[]>, {
        [key: string]: boolean[];
    }>;
    get asDictionaryOfNumberArray(): ComputeIfNode<ComputeDictionaryNode<ComputeArrayNode<ComputeNumberNode, number>, number[]>, {
        [key: string]: number[];
    }>;
    get asDictionaryOfStringArray(): ComputeIfNode<ComputeDictionaryNode<ComputeArrayNode<ComputeStringNode, string>, string[]>, {
        [key: string]: string[];
    }>;
    get asDictionaryOfDateArray(): ComputeIfNode<ComputeDictionaryNode<ComputeArrayNode<ComputeDateNode, Date>, Date[]>, {
        [key: string]: Date[];
    }>;
}
